#ifndef state_h
#define state_h

enum StateInfo {
	StateInfo_Continue,
	StateInfo_Immediate,
	StateInfo_Next
};

template<class PARENT>
class State {
protected:
	State() {}
public:
	virtual ~State() {}
	virtual StateInfo run(PARENT *parent, State<PARENT>* &newState) = 0;
	virtual void draw(PARENT *parent) {}
};

#endif
