// fNXeXgi|Sj

#pragma comment(lib, "dxguid.lib")
#pragma comment(lib, "d3d9.lib")
#pragma comment(lib, "d3dx9.lib")

#include <windows.h>
#include <tchar.h>
#include <d3d9.h>
#include <d3dx9.h>

#include "stage.h"

TCHAR gName[100] = _T("fNXeXgi|Sj");

#define SAFERELEASE( x ) if( x ){ x->Release(); x = 0; }

// EBhEvV[W
LRESULT CALLBACK WndProc( HWND hWnd, UINT mes, WPARAM wParam, LPARAM lParam ){
	if( mes == WM_DESTROY || mes == WM_CLOSE ) { PostQuitMessage( 0 ); return 0; }
	return DefWindowProc( hWnd, mes, wParam, lParam );
}


int APIENTRY _tWinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow )
{
	// AvP[V̏
	MSG msg; HWND hWnd;
	WNDCLASSEX wcex = { sizeof(WNDCLASSEX), CS_HREDRAW | CS_VREDRAW, WndProc, 0, 0, hInstance, NULL, NULL, (HBRUSH)(COLOR_WINDOW+1), NULL, (TCHAR*)gName, NULL};
	if( !RegisterClassEx(&wcex) )
		return 0;

	RECT R = { 0, 0, 640, 480 };
	AdjustWindowRect( &R, WS_OVERLAPPEDWINDOW, FALSE );
	if( !( hWnd = CreateWindow( gName, gName, WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, 0, R.right - R.left, R.bottom - R.top, NULL, NULL, hInstance, NULL ) ) )
		return 0;

	// Direct3D̏
	LPDIRECT3D9 g_pD3D;
	LPDIRECT3DDEVICE9 g_pD3DDev;
	if( !( g_pD3D = Direct3DCreate9( D3D_SDK_VERSION ) ) ) return 0;

	D3DPRESENT_PARAMETERS d3dpp = { 640, 480, D3DFMT_UNKNOWN, 0, D3DMULTISAMPLE_NONE, 0, D3DSWAPEFFECT_DISCARD, NULL, TRUE, TRUE, D3DFMT_D24S8, 0, D3DPRESENT_RATE_DEFAULT, D3DPRESENT_INTERVAL_DEFAULT }; 

	if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd, D3DCREATE_HARDWARE_VERTEXPROCESSING, &d3dpp, &g_pD3DDev ) ) )
	if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd, D3DCREATE_SOFTWARE_VERTEXPROCESSING, &d3dpp, &g_pD3DDev ) ) )
	{
	g_pD3D->Release();
	return 0;
	}

	D3DXMATRIX world, view, proj;
	D3DXMatrixIdentity(&world);
	D3DXMatrixLookAtLH(&view, &D3DXVECTOR3(0.0f, 0.0f, -100.0f), &D3DXVECTOR3(0.0f, 0.0f, 0.0f), &D3DXVECTOR3(0.0f, 1.0f, 0.0f));
	D3DXMatrixPerspectiveFovLH(&proj, D3DXToRadian(30.0f), 64.0f/48.0f, 1.0f, 1000.0f);

	g_pD3DDev->SetTransform(D3DTS_WORLD, &world);
	g_pD3DDev->SetTransform(D3DTS_VIEW, &view);
	g_pD3DDev->SetTransform(D3DTS_PROJECTION, &proj);


	////////////////////////////////
	// Xe[W쐬
	//////
//	Stage stage(g_pD3DDev, "stage01.dat");
	Stage stage(g_pD3DDev, "stage02.dat");

	ShowWindow(hWnd, nCmdShow);

	// bZ[W [v
	do{
		if( PeekMessage(&msg, NULL, 0, 0, PM_REMOVE) ){ DispatchMessage( &msg ); }

		stage.update();

		g_pD3DDev->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, D3DCOLOR_XRGB(40,40,80), 1.0f, 0 );
		// `
		g_pD3DDev->BeginScene();		 
		stage.draw();
		g_pD3DDev->EndScene();
		g_pD3DDev->Present( NULL, NULL, NULL, NULL );
	}while( msg.message != WM_QUIT );

	SAFERELEASE( g_pD3DDev );
	SAFERELEASE( g_pD3D );
	return 0;
}

