#ifndef variant_h
#define variant_h

// Kł`

#include <vector>
#include <fstream>

struct Variant {
	int iVal;
	std::string str;
	Variant(const char* v = 0) : str(v), iVal(atoi(v)) {}
};
typedef std::vector<Variant> Variants;

class StrUtil {
public:
	static Variants split(const char* str) {
		Variants ary;
		unsigned len = (unsigned)strlen(str);
		unsigned i, c = 0;
		char buf[128] = {};
		for (i = 0; i < len; i++) {
			if (str[i] == ',') {
				buf[i-c] = 0;
				Variant v(buf);
				ary.push_back(v);
				c = i + 1;
				continue;
			}
			buf[i-c] = str[i];
		}
		buf[i-c] = 0;
		Variant v(buf);
		ary.push_back(v);

		return ary;
	}

	static std::vector<Variants> parse(std::ifstream &ifs) {
		std::vector<Variants> ary;
		char buf[1024];
		while(!ifs.eof()) {
			ifs.getline(buf, 1024);
			if (buf[0] != '/')
				ary.push_back(split(buf));
		}
		return ary;
	}
};

#endif
